Program Model_3D;

Uses
  Crt, Graph;

Label Nothing;

Type
  Coord_2D = record
      x,y:integer
    end;
  Coord_3D = record
      x,y,z:integer
    end;

Const
  Cel = 20;
  Cpl = 30;

Type
  Cobj_3D = array[1..Cel] of Coord_3D;
  Cobj_2D = array[1..Cel] of Coord_2D;
  Obj_3D = record
      El : array[1..Cel] of Coord_3D;
      Pl : array[1..Cpl,1..2] of byte
    end;

Const
 TableCos:array[0..90] of integer = (
  16384,16382,16374,16362,16344,16322,16294,16262,16225,16182,
  16135,16083,16026,15964,15897,15826,15749,15668,15582,15491,
  15396,15296,15191,15082,14968,14849,14726,14598,14466,14330,
  14189,14044,13894,13741,13583,13421,13255,13085,12911,12733,
  12551,12365,12176,11982,11786,11585,11381,11174,10963,10749,
  10531,10311,10087, 9860, 9630, 9397, 9162, 8923, 8682, 8438,
   8192, 7943, 7692, 7438, 7182, 6924, 6664, 6402, 6138, 5872,
   5604, 5334, 5063, 4790, 4516, 4240, 3964, 3686, 3406, 3126,
   2845, 2563, 2280, 1997, 1713, 1428, 1143,  857,  572,  286, 0);
 Obj : Obj_3D =
   (El:((X:100; Y: 70; Z:  0),
        (X:100; Y:  0; Z:  0),
        (X:  0; Y:  0; Z:  0),
        (X:  0; Y: 70; Z:  0),
        (X:100; Y: 70; Z: 20),
        (X:100; Y: 50; Z: 20),
        (X:  0; Y: 50; Z: 20),
        (X:  0; Y: 70; Z: 20),
        (X:100; Y: 50; Z: 50),
        (X:100; Y:  0; Z: 50),
        (X:  0; Y:  0; Z: 50),
        (X:  0; Y: 50; Z: 50),
        (X: 80; Y: 40; Z:  0),
        (X: 80; Y: 10; Z:  0),
        (X: 40; Y: 10; Z:  0),
        (X: 40; Y: 40; Z:  0),
        (X: 80; Y: 40; Z: 50),
        (X: 80; Y: 10; Z: 50),
        (X: 40; Y: 10; Z: 50),
        (X: 40; Y: 40; Z: 50));
    Pl:((1,2),(2,3),(3,4),(4,1),(1,5),
        (5,6),(6,7),(7,8),(8,4),(6,9),
        (9,10),(10,11),(11,12),(12,7),(5,8),
        (9,12),(2,10),(3,11),(13,14),(14,15),
        (15,16),(16,13),(13,17),(17,18),(18,19),
        (19,20),(20,17),(14,18),(15,19),(16,20)));

Var
  Show,Hide,
  Xw,Yw,Zw,
  XSize,YSize,
  MX,MY,
  XC,YC,
  A,B,C,W,V,i,
  gm,gd:integer;
  ch:char;
  Cof : Cobj_2D;
  Cop : Cobj_3D;

Procedure Rotate(D:integer; Var X,Y:integer);
Var C,S:integer;
    X1,Y1:longint;
begin
  if ((X=0) and (Y=0)) or (D=0) then exit;
  asm
    mov  AX,D
    mov  BX,360
    xor  CX,CX
@m1:sub  AX,BX
    cmp  AX,CX
    jnl  @m1
@m2:add  AX,BX
    cmp  AX,CX
    jl   @m2
    mov  BX,90
@m3:cmp  AX,BX
    jl   @m4
    sub  AX,BX
    inc  CX
    jmp  @m3
@m4:sub  BX,AX
    shl  AX,1
    shl  BX,1
    Test CL,1
    jz   @m5
    xchg AX,BX
@m5:mov  SI,AX
    mov  AX,word PTR TableCos[SI]
    mov  C,AX
    mov  AX,word PTR TableCos[BX]
    mov  S,AX
    cmp  CL,1
    jl   @ex
    jg   @m6
@m7:neg  C
    jmp  @ex
@m6:neg  S
    cmp  CL,3
    jl   @m7
@ex:end;
  X1:=longint(X);
  Y1:=longint(Y);
  X:=(X1*C-Y1*S) shr 14;
  Y:=(X1*S+Y1*C) shr 14;
end;

Procedure Rotate_3D(A,B,C:integer; Var M:Coord_3D);
begin
 with M do begin
  Rotate(A,X,Y);
  Rotate(B,X,Z);
  Rotate(C,X,Y);
 end
end;

Procedure RotateObj( Xw,Yw,Zw,A,B,C:integer );
Var i:integer;

Function ScrCoord(AC,A,MA,Z:integer):integer;
Var DC:longint;
begin
  DC:=Longint(A)*MA;
  if (Z>1) then DC:=DC div Z;
  ScrCoord:=DC+AC
end;

begin
  for i:=1 to Cel do begin
    Cop[i]:=Obj.El[i];
    Rotate_3D(A,B,C,Cop[i]);
    with Cop[i] do begin
    X:=Xw+X;
    Y:=Yw+Y;
    Z:=Zw+Z;
    Cof[i].X:=ScrCoord(XC,X,MX,Z);
    Cof[i].Y:=ScrCoord(YC,Y,MY,Z);
  end end
end;


Procedure PutObj( Color:integer );
Var i:integer;
    _B,_E:Coord_2D;
begin
  SetColor(Color);
  for i:=1 to Cpl do begin
    _B:=Cof[Obj.Pl[i,1]];
    _E:=Cof[Obj.Pl[i,2]];
    Line(_B.X,_B.Y,_E.X,_E.Y)
  end;
end;

Procedure GoodBuy;
begin
  CloseGraph;
  Halt
end;

Begin
 gd:=Detect;
 InitGraph(gd,gm,'BGI');
 ClearDevice;

 Hide:=Black;
 Show:=White;

 XSize:=GetMaxX+1;
 YSize:=GetMaxY+1;
 XC:=XSize div 2;
 YC:=YSize div 2;
 MX:=3*XSize div 4;
 MY:=YSize;
 Xw:=15; Yw:=20; Zw:=200;
 A:=270; B:=230; C:=0;
 ch:=#0; W:=1; V:=10;

 RotateObj( Xw,Yw,Zw,A,B,C );
 PutObj(Show);

 While True do
  for i:=0 to 359 do begin
   Nothing:
   if KeyPressed or (W=0) then begin
    Ch:=ReadKey;
      case ch of
       'a':inc(A,V);
       'A':dec(A,V);
       'b':inc(B,V);
       'B':dec(B,V);
       'c':inc(C,V);
       'C':dec(C,V);
       '6':if Xw<1000 then inc(Xw,V);
       '4':if Xw>-1000 then dec(Xw,V);
       '2':if Yw<1000 then inc(Yw,V);
       '8':if Yw>-1000 then dec(Yw,V);
       '-':if Zw<1000 then inc(Zw,V);
       '+':if Zw>1 then dec(Zw,V);
       '0':if W<20 then inc(W);
       '.':if W>0 then dec(W);
       #27:GoodBuy;
       else goto Nothing
      end
   end;
   PutObj(Hide);

   RotateObj( Xw,Yw,Zw, A+i*w, B+i*w, C+i*w );
   PutObj(Show);
   Delay(50);

  end
End.
